<?php  																														require_once($_SERVER['DOCUMENT_ROOT'] . "/eclipse.org-common/system/app.class.php");	require_once($_SERVER['DOCUMENT_ROOT'] . "/eclipse.org-common/system/nav.class.php"); 	require_once($_SERVER['DOCUMENT_ROOT'] . "/eclipse.org-common/system/menu.class.php"); 	$App 	= new App();	$Nav	= new Nav();	$Menu 	= new Menu();		include($App->getProjectCommon());    # All on the same line to unclutter the user's desktop'

$pageTitle 		= "";
$pageKeywords	= "";
$pageAuthor		= "";

ob_start();
?>
    <div id="maincontent">
	<div id="midcolumn">

<h1>OCL Tools</h1>
</p>
<?php
include_once($_SERVER['DOCUMENT_ROOT'] . "/projects/fragments/proposal-page-header.php");
generate_header("YOUR PROPOSAL UNIQUE KEY HERE");
?>

<h2>I. Introduction</h2>

<p>
OCL Tools is a proposed open source component 
in the 
<a href="http://www.eclipse.org/modeling/mdt/">Model Development Tools (MDT)</a> Project to 
support the editing, refactoring, code generation, execution, 
and interactive debugging of the OCL constraints given for some underlying (Ecore or UML2) class model, 
building upon the infrastructure provided by the MDT OCL component. 

</p>

<p>
This proposal is in the Project Proposal Phase (as defined in the
<a href="http://www.eclipse.org/projects/dev_process/development_process.php">
Eclipse Development Process</a>
 document) and is written to declare its
intent and scope. This proposal is written to solicit additional
participation and input from the Eclipse community. You are invited to
comment on and/or join the component. Please send all feedback to the 
<a href="news://news.eclipse.org/eclipse.modeling.mdt">eclipse.modeling.mdt</a>
 newsgroup.
</p>

<h2>II. Background</h2>

The Eclipse infrastructure for modeling is based on EMF and UML2, with support
for OCL 2.0 (Object Constraint Language) provided by the Model
Development Tools (MDT) project. The expressive power of
OCL allows capturing a sizable amount of development
requirements in a declarative manner:

<ul>

<li>(a.1)
data modeling aspects can be expressed as an (Ecore or UML2) data
schema further constrained by OCL invariants;
</li>

<li>(a.2)
a number of functional requirements can be specified as
operation pre- and postconditions, together with
</li>

<li>(a.3)
side-effects-free queries (defining the values of instance
fields and operations)
</li>

</ul>

As of now, OCL constraints can be evaluated at runtime by:

<ul>

<li> (b.1) using the MDT OCL infrastructure to parse an OCL constraint from
its textual representation into its Abstract Syntax Tree (AST)
representation,
</li>

<li> (b.2) invoking an <tt>EvaluationVisitor</tt> (also provided by MDT OCL)
on the AST representation. Evaluation takes place in the context of an
object population.
</li>

</ul>

The steps required to realize (b.1) and (b.2) are explained in the references listed below. Carrying out such steps presupposes knowledge well beyond writing OCL expressions.

<ul>

<li> (c.1) for Ecore,  in an Eclipse Technical Article by Christian W. Damus
("
<a href="http://www.eclipse.org/articles/article.php?file=Article-EMF-Codegen-with-OCL/index.html">
Implementing Model Integrity in EMF with EMFT OCL
</a>
") <a href="#biblio1">[3]</a>,
with an exemplary realization (custom JET templates).
The user is expected to adapt such techniques
(for example, in case a text file contains the OCL constraints as
opposed to being available as annotations to an Ecore-based model).
</li>

<li>
(c.2) for UML2, at
<a href="http://wiki.eclipse.org/index.php/MDT_1.0_New_and_Noteworthy#OCL_Integration">
http://wiki.eclipse.org/index.php/MDT_1.0_New_and_Noteworthy#OCL_Integration
</a>
</li>

</ul>

In order to bring usability of OCL specs on par with that of EMF and UML2, 
at the very least an OCL compiler is necessary, building upon (Ecore,UML2) ->
Java code generation and weaving (a.1) through (a.3) into the
resulting Java code. In particular, the generated code can then be
directly used as the Model component in an MVC architecture (for
example, as part of a graphical editor generated with Eclipse GMF).
Additionally, the compiled OCL expressions execute faster (twice on
average) than their interpreted counterparts. In order to compare the performance of alternative compilation algorithms, a benchmark suite of OCL expressions would be desirable. 
</p>

<p>
For OCL specifications to be seamlessly integrated in an MDSD
toolchain, besides batch compilation, other tools are necessary: 
custom text editor, source-level debugging support, i.e. IDE capability. 
</p>

<h2>III. Scope</h2>

The objectives of the OCL Tools component are to:

<ul>

<li>
(d.1) provide a working implementation of a compilation algorithm
targeting both EMF and UML2. That algorithm (in its EMF specialization)
has been described in a
position paper <a href="#biblio2">[2]</a> submitted to the 
<a href="http://www.eclipsecon.org/summiteurope2007/index.php?page=symposia/#modeling">
Modeling Symposium
</a>
 at 
<a href="http://www.eclipsecon.org/summiteurope2007">
Eclipse Summit Europe 2007 
</a>
and has been implemented in the code contribution mentioned below. 
A related Eclipse Technical Article (
<a href="http://www.eclipse.org/articles/article.php?file=Article-HowToProcessOCLAbstractSyntaxTrees/index.html">
"How to Process OCL Abstract Syntax Trees"
</a>
) <a href="#biblio4">[4]</a> has been contributed by one of the authors of
this proposal, simplifying the learning curve for future contributors.
</li>

<li>
(d.2) provide sample (Ecore and UML2) + OCL models to speed up the adoption by
first-time users of OCL Tools. Initially, two
non-trivial models are to be made available: 

<ul>
<li>
(d.2.a) Royal & Loyal,
described in the book on OCL by Warmer and Kleppe; and 
</li>

<li>
(d.2.b) a metamodel
of the JPQL language (Java Persistence Query Language) which encodes
as OCL invariants all the well-formedness rules ("static semantics")
stated as English sentences in JSR-220 (described in 
<a href="http://www.sts.tu-harburg.de/~mi.garcia/pubs/atem06/paper/Garcia_ATEM06_Formalizing_the_well-formedness_rules_of_EJB3QL_in_UML_OCL.pdf">
this paper
</a>)
</li>

</ul>
</li>

<li>
(d.3)  solicit contributions to adapt the compilation algorithm
embedded in our implementation to other domains:
</li>

<ul>

<li>
(d.3.a) first and foremost, to accept UML2 class models as input,
</li>

<li>
(d.3.b) targeting object models other than Java
(for example, by translating OCL constraints into the
query language of Java Persistence API, the Object-Relational Mapping
technology standardized by JSR-220).
</li>

</ul>

<li>
(d.4) provide IDE capability: 
</li>

<ul>

<li>
(d.4.a) a text editor supporting usability features such as syntax-directed completion, markers
for violations of well-formedness, use-defs navigation, folding, and structural
views (e.g., OCLASTView <a href="#biblio4">[4]</a>)
</li>

<li>(d.4.b) refactoring support</li>

<li>(d.4.c) source-level, interactive debugging</li>


</ul>

</ul>


<h2>IV. Description</h2>

This section focuses on the functionality available in the code contribution. 
Pointers to related work are included in the next section ("Relationship with other Eclipse-based projects").

An OCL compiler is available, which follows the classical software architecture of a
batch compiler <a href="#biblio1">[1]</a>:

<ul>

<li>
(e.1) a front-end component, shared among all
"target architectures" (EMF and UML2). During the front-end phase,
textual input is parsed into Concrete Syntax Trees
(CSTs), which once validated are used to build the ASTs
that compilation proper takes as input. These two activities involve a
number of sub-steps, such as resolving mutual forward-references and
collecting error markers. These sub-steps are realized with
building blocks provided by MDT OCL, while bookkeeping and glue code
has been added to hold everything together.
</li>

<li>
(e.2) the in-memory copy of the input model (our compiler does not
modify the actual input) is decorated with EAnnotations that are
taken later by EMF CodeGen (and in the future by UML2 CodeGen)
as the source of method bodies and
additional declarations: helper methods, helper types (e.g.
those resulting from OCL tuples), and helper utilities (e.g. those to
track all instances in a <tt>ResourceSet</tt>, realizing OCL's <tt>allInstances()</tt>)
</li>

</ul>

Some patterns exhibited by the resulting code are (a more
comprehensive exposition can be found in <a href="#biblio2">[2]</a>):

<ul>

<li>
(f.1) OCL preconditions and postconditions are translated into Java
assert statements
</li>

<li>
(f.2) OCL define and derive statements are translated into getters
(for properties) and into method bodies (for operations)
</li>

<li>
(f.3) OCL invariants are translated into dedicated Java methods. It is
the responsibility of the user to invoke them at times deemed
appropriate.
</li>

</ul>


The OCL Compiler is packaged as an Eclipse plugin with a basic UI (an
action for an <tt>IFile</tt> to start compilation, a preferences page to
choose compilation options). The input (as of now) is assumed
to be a single <tt>.ecore</tt> file accompanied by an <tt>.ocl</tt> file with the same name.
</p>

<h2>V. Relationship with Other Eclipse-based Projects</h2>

<p>
The 
<a href="http://domino.research.ibm.com/comm/research_projects.nsf/pages/safari.Introduction.html">
SAFARI project</a> 
aims at generating an IDE out of the description of an object oriented, imperative programming language, 
in principle covering the whole spectrum from structured editing to interactive debugging. 
<a href="http://www.sts.tu-harburg.de/~mi.garcia/SoC2007/GenDSLToolsFromLangDef.pdf">
Other efforts</a>
have focused on the structured editing and AST-building phases, 
with an emphasis on using as internal representation of ASTs 
an instantiation of an Ecore + OCL language metamodel ("eat your own dog food"). 
</p>

<p>
<a href="http://www.alphaworks.ibm.com/tech/emfatic">
Emfatic</a> has been extended by one of the authors of this proposals, 
as documented in 
<a href="http://www.sts.tu-harburg.de/~mi.garcia/SoC2007/ImprovementsToTheEmfaticEditor.pdf">
http://www.sts.tu-harburg.de/~mi.garcia/SoC2007/ImprovementsToTheEmfaticEditor.pdf</a>
 and in 
<a href="http://www.sts.tu-harburg.de/~mi.garcia/SoC2007/draftreport.pdf">
http://www.sts.tu-harburg.de/~mi.garcia/SoC2007/draftreport.pdf
</a>
</p>

<p>
Refactoring of OCL expressions is the goal of the tool 
<a href="http://www.roclet.org">
http://www.roclet.org
</a>
</p>

<p>
As resources such as the above on IDE-related issues become available, 
their application in the context of this component will be considered. 
</p>

<h2>VI. Organization</h2>

<h3>VI.a) Initial committers</h3>

The initial committers will focus on evolving and hardening the OCL
compiler, as input models are contributed by the community. The
initial committers are also willing to provide know-how to the
community on OCL tooling in general (e.g, for those developing
translations from OCL into other languages, such as JPQL).  Our agile
development process will follow eclipse.org's standards for openness
and transparency.  The initial committers are:

<ul>

<li> Miguel Garcia (Technische Universitaet Hamburg-Harburg,
Germany), 
<a href="http://www.sts.tu-harburg.de/~mi.garcia/">
http://www.sts.tu-harburg.de/~mi.garcia/
</a> 
 </li>

<li>
A. Jibran Shidqie (Technische Universitaet Hamburg-Harburg, Germany)
</li> 

</ul>


<h3>VI.b) Code contributions</h3>

The OCL Compiler for EMF described by its authors in <a href="#biblio2">[2]</a>. 

<h3>VI.c) Interested parties</h3>

The team of initial committers will explore statements of interest
from persons experienced in OCL processing or willing to gain such
experience.

<h3>VI.d) Developer community</h3>

We expect the initial set of committers to grow, as the intial contribution
establishes a platform which automates the front-end phases of
OCL processing (a common need for most, if not all, OCL processing tasks).

There is an active OCL community, with participants from industry and
academia attending (among others) the OCL workshop series at the
MoDELS conference (
<a href="http://st.inf.tu-dresden.de/Ocl4All2007/">
http://st.inf.tu-dresden.de/Ocl4All2007/
</a>
 ). The
techniques advanced by this community can naturally build upon and extend the
tooling proposed here. 

Similarly, members of the growing QVT community usually have a
background in OCL processing, and would be willing to have OCL play a
bigger role in their techniques provided the proposed infrastructure is
available.


<h3>VI.e) User community</h3>

Feedback from a large user community of commercial developers is
critical to harvesting real-world and complete OCL
specifications. Actually, harvesting such specifications reveals an
egg-and-chicken problem: those specifying a system have a reduced
incentive to invest effort in preparing OCL specs if they are to
remain paper-only and thus not automatically enforceable. On the other
hand, the developers of OCL tooling are reluctant to target a small
audience. The OCL compiler component is good positioned to break this
cycle, providing immediate benefit to the authors of OCL
specifications in the form of a portable and efficient implementation
of the (Ecore,UML2) + OCL spec given as input.

The availability of OCL tooling will also expand the user base
of directly related projects/components (OCL, EMF, UML2) thus 
accelerating the synergies of the Eclipse ecosystem.

<h2>VII. Tentative Plan</h2>

<ul>
<li>
2007-07 v0.1: internal release for study in the EMF, UML2 and MDT OCL teams
</li>
<li>
2005-08 v0.2: public release for community study
</li>
</ul>

<h2>References</h2>

<dl>

<dt><a name="biblio1">[1]</a>
<dd>
A. W. Appel and J. Palsberg. </br>
Modern Compiler Implementation in Java. Cambridge University Press, New York, NY, USA, 2003.</br>
<a href="http://www.cs.princeton.edu/~appel/modern/java/">
    http://www.cs.princeton.edu/~appel/modern/java/
</a>
</dd>
</dt>

<dt><a name="biblio2">[2]</a>
<dd>
OCL Compiler for EMF. </br>
Garcia, M. and Shidqie, A. J. </br>
Submission to Modeling Symposium at Eclipse Summit Europe 2007. </br>
</dd>
</dt>

<dt><a name="biblio3">[3]</a>
<dd>
<a href="http://www.eclipse.org/articles/article.php?file=Article-EMF-Codegen-with-OCL/index.html">
Implementing Model Integrity in EMF with MDT OCL
</a> </br>
    Christian W. Damus, Eclipse Technical Article,

</dd>
</dt>

<dt><a name="biblio4">[4]</a>
<dd>
<a href="http://www.eclipse.org/articles/article.php?file=Article-HowToProcessOCLAbstractSyntaxTrees/index.html">
How to process OCL Abstract Syntax Trees
</a> </br>
    Miguel Garcia, Eclipse Technical Article,
</dd>
</dt>

</dl>

      </div>
  </div>
<?php
	$html = ob_get_contents();
	ob_end_clean();

	# Generate the web page
	$App->generatePage($theme, $Menu, $Nav, $pageAuthor, $pageKeywords, $pageTitle, $html);
?>
